//
//  THLookupOption.h
//  Thesaurus
//
//  Created by Martin on Fri Apr 18 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "THWordNetSynset.h"


@interface THLookupOption : NSObject <NSCopying> {
    NSString* _displayName;
    NSString* _formatDisplay;	// format string, eg: "Synonyns for %@"
    SEL _lookupRelation;	// method to call on THWordNetEntry to get lookups
    int _index;
}

+ (NSArray*) standardOptions ;

- (NSString*) displayName ;
- (void) setDisplayName:(NSString*)name ;

- (NSString*) formatDisplay ;
- (void) setFormatDisplay:(NSString*)fmt ;

- (SEL) lookupRelation ;
- (void) setLookupRelation:(SEL)sel ;

// returns an array of THWordNetEntry objects for the given synset.
- (NSArray*) entriesForSynset:(THWordNetSynset*)synset ;

@end



