//
//  THThesaurusManager.h
//  Thesaurus
//
//  Created by Martin on Mon Aug 18 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.

#import <Foundation/Foundation.h>

#import <NisusThesaurus/THThesaurusLanguage.h>
#import <NisusThesaurus/THThesaurusLookupResult.h>
#import <NisusThesaurus/THWordNetEntry.h>


@interface THThesaurusManager : NSObject {
    NSMutableArray* _langs;
    THThesaurusLanguage* _lang;
    
    NSLock* _tmLock;
    BOOL _isTmLockHeld;
}

+ (THThesaurusManager*) sharedManager ;
- (double) managerVersion ;

- (THThesaurusLanguage*) languageWithLanguageCode:(NSString*)code ;

- (NSArray*) availableLanguages ;

// sets/gets the current thesaurus language to use for lookups
- (void) setLanguageCode:(NSString*)langCode ;
- (void) setLanguage:(THThesaurusLanguage*)lang ;
- (THThesaurusLanguage*) language ;

// gets a result set using the current language
- (BOOL) isWordKnown:(NSString*)word ;
- (THWordNetEntry*) entryForWord:(NSString*)word ;
- (THWordNetEntry*) randomEntry ;

- (THThesaurusLookupResult*) lookupWord:(NSString*)word ;
- (THThesaurusLookupResult*) lookupWord:(NSString*)word language:(THThesaurusLanguage*)lang ;

// thread safety
- (BOOL) tryManagerLock ;
- (BOOL) lockManagerBeforeDate:(NSDate*)date ;
- (BOOL) lockManagerBeforeTimeInterval:(NSTimeInterval)delta ;
- (void) unlockManager ;

@end
